#include <gpdef.h>
#include <gpstdlib.h>
#include <gpgraphic.h>
#include <gpgraphic16.h>

#include "../include/global.h"
#include "../include/graphics16.h"
#include "../include/okf.h"

#include "project.h"
#include "properties.h"


void Properties(void)
{
  int pressedKeys, newKeys, oldKeys;
  int top=35;
  int i, n, temp;
  char str[270], str2[100];
  OKFFONT *pFont;
  OKFENGINE oldState;

  pFont = OkfGetCurrentFont();

  // Initialize to default values
  oldState = okf;
  OkfSetToDefaults();
  okf.font = 3;

  while(GpKeyGet());
  while(TRUE)
  {
    // Background
    GpRectFill16(NULL, &gtSurface[giSurface], 0, 0, GPC_LCD_WIDTH, GPC_LCD_HEIGHT, RGB(31, 31, 31));

    // Font properties
    okf.y = top;
    //-
    OkfPrintAt(10, okf.y, "File size");
    gm_sprintf(str2, "%ld", pFont->pOkf->fileSize);
    gm_sprintf(str, ": %s bytes\n", Thousands(str2));
    OkfPrintAt(160, okf.y, str);
    //-
    OkfPrintAt(10, okf.y, "Version");
    gm_sprintf(str, ": %ld\n", pFont->pOkf->version);
    OkfPrintAt(160, okf.y, str);

    OkfPrint("\n\n");
    GpRectFill16(NULL, &gtSurface[giSurface], 0, okf.y - 11, GPC_LCD_WIDTH, 1, RGB(0, 0, 0));

    //-
    OkfPrintAt(10, okf.y, "Font name");
    gm_memset(str2, 0, sizeof(str));
    gm_memcpy(str2, pFont->pOkf->name, sizeof(pFont->pOkf->name));
    gm_sprintf(str, ": %s\n", str2);
    OkfPrintAt(160, okf.y, str);
    //-
    OkfPrintAt(10, okf.y, "Font size");
    gm_sprintf(str, ": %ld\n", pFont->pOkf->size);
    OkfPrintAt(160, okf.y, str);

    OkfPrint("\n\n");
    GpRectFill16(NULL, &gtSurface[giSurface], 0, okf.y - 11, GPC_LCD_WIDTH, 1, RGB(0, 0, 0));

    //-
    OkfPrintAt(10, okf.y, "Flags");
    gm_sprintf(str, ": 0x%04X\n", (pFont->pOkf->flags2 << 8) + pFont->pOkf->flags1);
    OkfPrintAt(160, okf.y, str);
    //-
    OkfPrintAt(20, okf.y + 5, "Color depth");
    OkfPrintAt(160, okf.y, pFont->pOkf->colorDepth ? ": 16 bits\n" : ": 8 bits\n");
    //-
    OkfPrintAt(20, okf.y, "Bitmap encoding");
    OkfPrintAt(160, okf.y, pFont->pOkf->bitmapRLEEncoded ? ": RLE\n" : ": RAW\n");
    //-
    OkfPrintAt(20, okf.y, "Alpha mask");
    OkfPrintAt(160, okf.y, pFont->pOkf->alphaMask ? ": Present\n" : ": Not present\n");
    //-
    OkfPrintAt(20, okf.y, "Mask encoding");
    OkfPrintAt(160, okf.y, pFont->pOkf->maskRLEEncoded ? ": RLE\n" : ": RAW\n");
    //-
    OkfPrintAt(20, okf.y, "Shadow mask");
    OkfPrintAt(160, okf.y, pFont->pOkf->shadowMask ? ": Yes\n" : ": No\n");
    //-
    OkfPrintAt(20, okf.y, "Left/right indents");
    OkfPrintAt(160, okf.y, pFont->pOkf->indents ? ": Present\n" : ": Not present\n");
    //-
    OkfPrintAt(20, okf.y, "Postprocessed");
    OkfPrintAt(160, okf.y, pFont->pOkf->postProcessed ? ": Yes\n" : ": No\n");
    //-
    OkfPrintAt(20, okf.y, "Font pitch");
    OkfPrintAt(160, okf.y, pFont->pOkf->proportional ? ": Proportional\n" : ": Monospaced\n");
    //-
    OkfPrintAt(20, okf.y, "Font with serif");
    OkfPrintAt(160, okf.y, pFont->pOkf->serif ? ": Yes\n" : ": No\n");
    //-
    OkfPrintAt(20, okf.y, "Script font");
    OkfPrintAt(160, okf.y, pFont->pOkf->script ? ": Yes\n" : ": No\n");
    //-
    OkfPrintAt(20, okf.y, "Bold");
    OkfPrintAt(160, okf.y, pFont->pOkf->bold ? ": Yes\n" : ": No\n");
    //-
    OkfPrintAt(20, okf.y, "Italic");
    OkfPrintAt(160, okf.y, pFont->pOkf->italic ? ": Yes\n" : ": No\n");
    //-
    OkfPrintAt(20, okf.y, "Underline");
    OkfPrintAt(160, okf.y, pFont->pOkf->underline ? ": Yes\n" : ": No\n");
    //-
    OkfPrintAt(20, okf.y, "Strikethrough");
    OkfPrintAt(160, okf.y, pFont->pOkf->strikethrough ? ": Yes\n" : ": No\n");

    OkfPrint("\n\n");
    GpRectFill16(NULL, &gtSurface[giSurface], 0, okf.y - 11, GPC_LCD_WIDTH, 1, RGB(0, 0, 0));

    //-
    OkfPrintAt(10, okf.y, "Default char width");
    gm_sprintf(str, ": %ld\n", pFont->pOkf->defaultWidth);
    OkfPrintAt(160, okf.y, str);
    //-
    OkfPrintAt(10, okf.y, "Default char height");
    gm_sprintf(str, ": %ld\n", pFont->pOkf->defaultHeight);
    OkfPrintAt(160, okf.y, str);
    //-
    OkfPrintAt(10, okf.y, "Max char width");
    gm_sprintf(str, ": %ld\n", pFont->pOkf->maxWidth);
    OkfPrintAt(160, okf.y, str);
    //-
    OkfPrintAt(10, okf.y, "Max char height");
    gm_sprintf(str, ": %ld\n", pFont->pOkf->maxHeight);
    OkfPrintAt(160, okf.y, str);
    //-
    OkfPrintAt(10, okf.y, "Default line separation");
    gm_sprintf(str, ": %ld\n", pFont->pOkf->lineSeparation);
    OkfPrintAt(160, okf.y, str);
    //-
    OkfPrintAt(10, okf.y, "Default char separation");
    gm_sprintf(str, ": %ld\n", pFont->pOkf->charSeparation);
    OkfPrintAt(160, okf.y, str);
    //-
    OkfPrintAt(10, okf.y, "Trans. color");
    GpRectFill16(NULL, &gtSurface[giSurface], 220, okf.y + 2, 15, 11, RGB(0, 0, 0));
    GpRectFill16(NULL, &gtSurface[giSurface], 221, okf.y + 3, 13,  9, pFont->pOkf->transColor);
    gm_sprintf(str, ": 0x%04X\n", pFont->pOkf->transColor);
    OkfPrintAt(160, okf.y, str);

    OkfPrint("\n\n");
    GpRectFill16(NULL, &gtSurface[giSurface], 0, okf.y - 11, GPC_LCD_WIDTH, 1, RGB(0, 0, 0));

    //-
    OkfPrintAt(10, okf.y, "Bitmap offset");
    gm_sprintf(str2, "%ld", pFont->pOkf->bitmapOffset);
    gm_sprintf(str, ": 0x%04X (%s)\n", pFont->pOkf->bitmapOffset, Thousands(str2));
    OkfPrintAt(160, okf.y, str);
    //-
    OkfPrintAt(10, okf.y, "Bitmap size (W x H)");
    gm_sprintf(str2, "%ld", pFont->pOkf->bitmapWidth);
    gm_sprintf(str, ": %s x %ld\n", Thousands(str2), pFont->pOkf->bitmapHeight);
    OkfPrintAt(160, okf.y, str);
    //-
    OkfPrintAt(10, okf.y, "Bitmap compression");
    temp = pFont->pOkf->fileSize - pFont->pOkf->bitmapOffset;
    if (pFont->pOkf->alphaMask)
      temp -= pFont->pOkf->fileSize - pFont->pOkf->maskOffset;
    temp *= 100;
    temp /= pFont->pOkf->bitmapWidth * pFont->pOkf->bitmapHeight * (pFont->pOkf->colorDepth ? 2 : 1);
    gm_sprintf(str, ": %ld%%\n\n", temp);
    OkfPrintAt(160, okf.y, str);

    //-
    OkfPrintAt(10, okf.y, "Mask offset");
    gm_sprintf(str2, "%ld", pFont->pOkf->maskOffset);
    gm_sprintf(str, ": 0x%04X (%s)\n", pFont->pOkf->maskOffset, Thousands(str2));
    OkfPrintAt(160, okf.y, str);
    //-
    OkfPrintAt(10, okf.y, "Mask size (W x H)");
    if (pFont->pOkf->alphaMask)
    {
      gm_sprintf(str2, "%ld", pFont->pOkf->bitmapWidth + pFont->pOkf->maskWidthInc * pFont->pOkf->nbChars);
      gm_sprintf(str, ": %s x %ld\n", Thousands(str2), pFont->pOkf->bitmapHeight + pFont->pOkf->maskHeightInc);
    }
    else
      gm_strcpy(str, ": 0 x 0\n");
    OkfPrintAt(160, okf.y, str);
    //-
    OkfPrintAt(10, okf.y, "Mask compression");
    temp = 0;
    if (pFont->pOkf->alphaMask)
      temp = (pFont->pOkf->fileSize - pFont->pOkf->maskOffset) * 100;
    temp /= (pFont->pOkf->bitmapWidth + pFont->pOkf->maskWidthInc * pFont->pOkf->nbChars) * 
            (pFont->pOkf->bitmapHeight + pFont->pOkf->maskHeightInc);
    gm_sprintf(str, ": %ld%%\n", temp);
    OkfPrintAt(160, okf.y, str);
    //-
    OkfPrintAt(10, okf.y, "Mask width increment");
    gm_sprintf(str, ": %ld\n", pFont->pOkf->maskWidthInc);
    OkfPrintAt(160, okf.y, str);
    //-
    OkfPrintAt(10, okf.y, "Mask height increment");
    gm_sprintf(str, ": %ld\n", pFont->pOkf->maskHeightInc);
    OkfPrintAt(160, okf.y, str);
    //-
    OkfPrintAt(10, okf.y + 5, "Shadow origin");
    gm_sprintf(str, ": X=%ld  Y=%ld\n", pFont->pOkf->shadowOX, pFont->pOkf->shadowOY);
    OkfPrintAt(160, okf.y, str);
    //-
    OkfPrintAt(10, okf.y, "Default shadow position");
    gm_sprintf(str, ": X=%ld  Y=%ld\n", pFont->pOkf->shadowXPos, pFont->pOkf->shadowYPos);
    OkfPrintAt(160, okf.y, str);
    //-
    OkfPrintAt(10, okf.y, "Default shadow color");
    GpRectFill16(NULL, &gtSurface[giSurface], 220, okf.y + 2, 15, 11, RGB(0, 0, 0));
    GpRectFill16(NULL, &gtSurface[giSurface], 221, okf.y + 3, 13,  9, pFont->pOkf->shadowColor);
    gm_sprintf(str, ": 0x%04X\n", pFont->pOkf->shadowColor);
    OkfPrintAt(160, okf.y, str);

    OkfPrint("\n\n");
    GpRectFill16(NULL, &gtSurface[giSurface], 0, okf.y - 11, GPC_LCD_WIDTH, 1, RGB(0, 0, 0));

    //-
    gm_sprintf(str, "Character set (%ld symbols):\n", pFont->pOkf->nbChars);
    OkfPrintAt(10, okf.y, str);
    gm_memset(str, 0, sizeof(str));
    for (i=0, n=0; i < pFont->pOkf->nbChars; n++)
    {
      str[n] = pFont->charSet[i] > 0x20 ? pFont->charSet[i] : 0x20;
      if (++i % 32 == 0)
        str[++n] = '\n';
    }
    if (i % 32 != 0)
      str[n] = '\n';
    okf.font = 4;
    OkfPrintAt(45, okf.y + 5, str);
    okf.font = 3;

    OkfPrint("\n\n");
    GpRectFill16(NULL, &gtSurface[giSurface], 0, okf.y - 11, GPC_LCD_WIDTH, 1, RGB(0, 0, 0));

    //- Samples
    //-
    OkfPrintAt(10, okf.y, "Bitmap sample:\n");
    okf.y += 5;
    GpRectDraw16(&gtSurface[giSurface], 10, okf.y, 309, okf.y + pFont->pOkf->bitmapHeight + 1, RGB(0, 0, 0));
    GpTransBlt16(NULL, &gtSurface[giSurface], 11, okf.y + 1, 298, pFont->pOkf->bitmapHeight,
                 pFont->pBitmap, 0, 0, pFont->bitmapWidth, pFont->bitmapHeight, 0);
    okf.y += pFont->pOkf->bitmapHeight;
    OkfPrint("\n");
    //-
    if (pFont->pOkf->alphaMask)
    {
      //-
      OkfPrintAt(10, okf.y, "Mask sample:\n");
      okf.y += 5;
      GpRectDraw16(&gtSurface[giSurface], 10, okf.y, 309, okf.y + pFont->pOkf->bitmapHeight + pFont->pOkf->maskHeightInc + 1, RGB(0, 0, 0));
      BitBltGrayTo16(NULL, &gtSurface[giSurface], 11, okf.y + 1, 298, pFont->pOkf->bitmapHeight + pFont->pOkf->maskHeightInc,
                     pFont->pMask, 0, 0, pFont->maskWidth, pFont->maskHeight);
      okf.y += pFont->pOkf->bitmapHeight + pFont->pOkf->maskHeightInc;
      OkfPrint("\n");
    }
    //-
    OkfPrintAt(10, okf.y, "Font sample:\n");
    gm_memset(str, 0, sizeof(str));
    okf.font = oldState.font;
    for (i=0; i < pFont->pOkf->nbChars && OkfGetTextWidth(str) <= 298; i++)
      str[i] = pFont->charSet[i];
    str[i - 1] = '\0';
    okf.y += 5;
    GpRectDraw16(&gtSurface[giSurface], 10, okf.y, 309, okf.y + pFont->pOkf->defaultHeight + 1, RGB(0, 0, 0));
    OkfPrintAt(11, okf.y + 1, str);
    okf.y += pFont->pOkf->defaultHeight + 5;
    GpRectFill16(NULL, &gtSurface[giSurface], 10, okf.y, 300, pFont->pOkf->defaultHeight + 2, RGB(0, 0, 0));
    OkfPrintAt(11, okf.y + 1, str);
    okf.y += pFont->pOkf->defaultHeight + 5;
    okf.font = 3;
    OkfPrint("\n");

    //- Current font
    GpRectFill16(NULL, &gtSurface[giSurface], 0, 0, GPC_LCD_WIDTH, 27, RGB(31, 31, 31));
    OkfPrintAt(10, 5, "Current font");
    gm_sprintf(str, ": %ld of %ld\n", ListGetIndex(ListGetItemByObject(okf.pFonts, pFont)) + 1, okf.pFonts->count);
    OkfPrintAt(160, okf.y, str);

    OkfPrint("\n");
    GpRectFill16(NULL, &gtSurface[giSurface], 0, 25, GPC_LCD_WIDTH, 1, RGB(0, 0, 0));


    SurfaceFlip();

    // Get buttons state
    oldKeys = pressedKeys;
    newKeys = pressedKeys = GpKeyGet();

    // Filter buttons
    if ((newKeys & GPC_VK_LEFT) && (oldKeys & GPC_VK_LEFT))
      newKeys = newKeys & ~GPC_VK_LEFT;
    if ((newKeys & GPC_VK_RIGHT) && (oldKeys & GPC_VK_RIGHT))
      newKeys = newKeys & ~GPC_VK_RIGHT;
    if ((newKeys & GPC_VK_FL) && (oldKeys & GPC_VK_FL))
      newKeys = newKeys & ~GPC_VK_FL;
    if ((newKeys & GPC_VK_FR) && (oldKeys & GPC_VK_FR))
      newKeys = newKeys & ~GPC_VK_FR;

    // Manage buttons
    if (newKeys & (GPC_VK_FA | GPC_VK_FB | GPC_VK_START))
    {
      break;
    }
    else if (newKeys & GPC_VK_SELECT)
    {
      MessageBox("Font Properties Help", 30, 30, 260, 180,
                 "All the properties of the OKF font file are presented here, except character widths and character left/right indents.\n\n"
                 "An important thing to keep in mind is that the character set presented before the font samples can be different from the real symbols represented in the font.\n"
                 "That can happen for example when the designer has used some characters for special icons or for foreign character sets.\n\n"
                 "At the end you will find samples of the real bitmaps contained in the font and a sample of the resulting font.\n");
    }
    else if (newKeys & GPC_VK_UP)
    {
      if ((top += 2) > 35)
        top = 35;
    }
    else if (newKeys & GPC_VK_DOWN)
    {
      if ((top -= 2) < -700)
        top = -700;
    }
    else if (newKeys & GPC_VK_LEFT)
    {
      if ((top += 213) > 35)
        top = 35;
    }
    else if (newKeys & GPC_VK_RIGHT)
    {
      if ((top -= 213) < -700)
        top = -700;
    }
    else if (newKeys & GPC_VK_FL)
    {
      LISTITEM *pItem;

      if ((pItem = ListGetItemByObject(okf.pFonts, pFont)->pPrevious) != NULL)
        pFont = pItem->pObject;
      else
        pFont = okf.pFonts->pLast->pObject;
      oldState.font = ListGetItemByObject(okf.pFonts, pFont)->handle;
    }
    else if (newKeys & GPC_VK_FR)
    {
      LISTITEM *pItem;

      if ((pItem = ListGetItemByObject(okf.pFonts, pFont)->pNext) != NULL)
        pFont = pItem->pObject;
      else
        pFont = okf.pFonts->pFirst->pObject;
      oldState.font = ListGetItemByObject(okf.pFonts, pFont)->handle;
    }
  }

  // Restore old engine state
  okf = oldState;

  // Updates current font
  okf.font = ListGetItemByObject(okf.pFonts, pFont)->handle;

  while(GpKeyGet());
}
